Attribute VB_Name = "Global"
Option Explicit

Public Const PS_SOLID = 0
Public Const DFC_BUTTON = 4
Public Const DFCS_BUTTONPUSH = &H10
Public Const DFCS_PUSHED = &H200
Public Const DFCS_INACTIVE = &H100
Public Const DFCS_MONO = &H8000
Public Const BDR_RAISEDINNER = &H4
Public Const BDR_RAISEDOUTER = &H1
Public Const EDGE_RAISED = (BDR_RAISEDOUTER Or BDR_RAISEDINNER)
Public Const BF_LEFT = &H1
Public Const BF_TOP = &H2
Public Const BF_RIGHT = &H4
Public Const BF_BOTTOM = &H8
Public Const BF_SOFT = &H1000
Public Const BF_RECT = (BF_LEFT Or BF_TOP Or BF_RIGHT Or BF_BOTTOM)
Public Const BDR_SUNKENINNER = &H8
Public Const BDR_SUNKENOUTER = &H2
Public Const EDGE_SUNKEN = (BDR_SUNKENOUTER Or BDR_SUNKENINNER)
Public Const BF_FLAT = &H4000     ' For flat rather than 3-D borders.

Public Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

Public Type POINTAPI
    X As Long
    Y As Long
End Type

Public Type SquareCoorType
    Up As POINTAPI
    Left As POINTAPI
    Right As POINTAPI
    Down As POINTAPI
End Type

Public Enum RotationEnum
    Clockwise = 0
    CounterClockwise
End Enum

Public Enum AxisEnum
    XAxis = 0
    YAxis
    ZAxis
End Enum

Public Enum FaceEnum
    fFront = 0
    fRight
    fTop
    fBottom
    fBack
    fLeft
End Enum

Public Declare Function Polygon Lib "gdi32" (ByVal hdc As Long, lpPoint As POINTAPI, ByVal nCount As Long) As Long
Public Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long
Public Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Public Declare Function CreatePen Lib "gdi32" (ByVal nPenStyle As Long, ByVal nWidth As Long, ByVal crColor As Long) As Long
Public Declare Function CreateSolidBrush Lib "gdi32" (ByVal crColor As Long) As Long
Public Declare Function DrawEdge Lib "user32" (ByVal hdc As Long, qrc As RECT, ByVal edge As Long, ByVal grfFlags As Long) As Long

Public SquareCoor(0 To 2, 0 To 2, 0 To 2) As SquareCoorType
Public SquareCoor2(0 To 2, 0 To 2, 0 To 2) As SquareCoorType
Public SquareColor(0 To 5, 0 To 2, 0 To 2) As OLE_COLOR
Public SquareColor2(0 To 5, 0 To 2, 0 To 2) As OLE_COLOR

Private Function ConvertToSquareInfoType(UpX As Integer, UpY As Integer, LeX As Integer, LeY As Integer, RiX As Integer, RiY As Integer, LoX As Integer, LoY As Integer) As SquareCoorType
    Dim Temp As POINTAPI
    Temp.X = UpX
    Temp.Y = UpY
    ConvertToSquareInfoType.Up = Temp
    Temp.X = LeX
    Temp.Y = LeY
    ConvertToSquareInfoType.Left = Temp
    Temp.X = RiX
    Temp.Y = RiY
    ConvertToSquareInfoType.Right = Temp
    Temp.X = LoX
    Temp.Y = LoY
    ConvertToSquareInfoType.Down = Temp
End Function

Public Sub LoadSquareInfo()
    LoadCoor 20, 45, SquareCoor
    LoadCoor 217, 45, SquareCoor2
    LoadColors
End Sub

Private Sub LoadColors()
    Dim Foo As Variant, Foo2 As Variant
    Dim Face As Byte, Row As Byte, Col As Byte
    Foo = Array(RGB(255, 255, 0), RGB(255, 128, 64), RGB(255, 255, 255), RGB(0, 0, 255), RGB(0, 255, 0), RGB(255, 0, 0))
    Foo2 = Array(RGB(0, 255, 0), RGB(255, 0, 0), RGB(0, 0, 255), RGB(255, 255, 255), RGB(255, 255, 0), RGB(255, 128, 64))
    For Face = fFront To fLeft
        For Row = 0 To 2
            For Col = 0 To 2
                SquareColor(Face, Row, Col) = Foo(Face)
                SquareColor2(Face, Row, Col) = Foo2(Face)
            Next Col
        Next Row
    Next Face
End Sub

Private Sub LoadCoor(XOffSet As Integer, YOffSet As Integer, Arr() As SquareCoorType)
    Dim Face As Byte, Row As Byte, Col As Byte
    For Row = 0 To 2
        For Col = 0 To 2
            Arr(0, Row, Col) = ConvertToSquareInfoType(XOffSet, YOffSet, XOffSet, YOffSet + 30, XOffSet + 26, YOffSet + 13, XOffSet + 26, YOffSet + 43)
            XOffSet = Arr(0, Row, Col).Right.X
            YOffSet = Arr(0, Row, Col).Right.Y
        Next Col
        XOffSet = Arr(0, Row, 0).Left.X
        YOffSet = Arr(0, Row, 0).Left.Y
    Next Row
    XOffSet = Arr(0, 0, 2).Right.X
    YOffSet = Arr(0, 0, 2).Right.Y
    For Row = 0 To 2
        For Col = 0 To 2
            Arr(1, Row, Col) = ConvertToSquareInfoType(XOffSet, YOffSet, XOffSet, YOffSet + 30, XOffSet + 26, YOffSet - 13, XOffSet + 26, YOffSet + 17)
            XOffSet = Arr(1, Row, Col).Right.X
            YOffSet = Arr(1, Row, Col).Right.Y
        Next Col
        XOffSet = Arr(1, Row, 0).Left.X
        YOffSet = Arr(1, Row, 0).Left.Y
    Next Row
    XOffSet = Arr(0, 0, 2).Right.X
    YOffSet = Arr(0, 0, 2).Right.Y - 3 * 26
    For Row = 0 To 2
        For Col = 0 To 2
            Arr(2, Row, Col) = ConvertToSquareInfoType(XOffSet, YOffSet, XOffSet - 26, YOffSet + 13, XOffSet + 26, YOffSet + 13, XOffSet, YOffSet + 26)
            XOffSet = Arr(2, Row, Col).Right.X
            YOffSet = Arr(2, Row, Col).Right.Y
        Next Col
        XOffSet = Arr(2, Row, 0).Left.X
        YOffSet = Arr(2, Row, 0).Left.Y
    Next Row
End Sub

Public Sub RotateFace(Colors() As OLE_COLOR, Face As FaceEnum, Rotation As RotationEnum)
    Dim Temp As OLE_COLOR
    Dim Count1 As Integer
    Dim Count2 As Byte
    Dim TempArr() As String, Coor1() As String, Coor2() As String
    Count1 = Val("1" & Format(Face) & Format(Rotation) & "00")
    For Count1 = Count1 To Count1 + 14
        Count2 = Count2 + 1
        If Count2 = 1 Then
            TempArr = Split(LoadResString(Count1), "=")
            Coor1 = Split(TempArr(0), ",")
            Coor2 = Split(TempArr(1), ",")
            Temp = Colors(Val(Coor1(0)), Val(Coor1(1)), Val(Coor1(2)))
            Colors(Val(Coor1(0)), Val(Coor1(1)), Val(Coor1(2))) = Colors(Val(Coor2(0)), Val(Coor2(1)), Val(Coor2(2)))
        ElseIf Count2 = 2 Then
            TempArr = Split(LoadResString(Count1), "=")
            Coor1 = Split(TempArr(0), ",")
            Coor2 = Split(TempArr(1), ",")
            Colors(Val(Coor1(0)), Val(Coor1(1)), Val(Coor1(2))) = Colors(Val(Coor2(0)), Val(Coor2(1)), Val(Coor2(2)))
        Else
            TempArr = Split(LoadResString(Count1), "=")
            Coor1 = Split(TempArr(0), ",")
            Coor2 = Split(TempArr(1), ",")
            Colors(Val(Coor1(0)), Val(Coor1(1)), Val(Coor1(2))) = Colors(Val(Coor2(0)), Val(Coor2(1)), Val(Coor2(2)))
            Colors(Val(Coor2(0)), Val(Coor2(1)), Val(Coor2(2))) = Temp
            Count2 = 0
        End If
    Next Count1
End Sub

Public Sub RotateMiddle(Colors() As OLE_COLOR, Axis As AxisEnum, Rotation As RotationEnum)
    Dim Temp As OLE_COLOR
    Dim Count1 As Integer
    Dim Count2 As Byte
    Dim TempArr() As String, Coor1() As String, Coor2() As String
    Count1 = Val("2" & Format(Axis) & Format(Rotation) & "0")
    For Count1 = Count1 To Count1 + 8
        Count2 = Count2 + 1
        If Count2 = 1 Then
            TempArr = Split(LoadResString(Count1), "=")
            Coor1 = Split(TempArr(0), ",")
            Coor2 = Split(TempArr(1), ",")
            Temp = Colors(Val(Coor1(0)), Val(Coor1(1)), Val(Coor1(2)))
            Colors(Val(Coor1(0)), Val(Coor1(1)), Val(Coor1(2))) = Colors(Val(Coor2(0)), Val(Coor2(1)), Val(Coor2(2)))
        ElseIf Count2 = 2 Then
            TempArr = Split(LoadResString(Count1), "=")
            Coor1 = Split(TempArr(0), ",")
            Coor2 = Split(TempArr(1), ",")
            Colors(Val(Coor1(0)), Val(Coor1(1)), Val(Coor1(2))) = Colors(Val(Coor2(0)), Val(Coor2(1)), Val(Coor2(2)))
        Else
            TempArr = Split(LoadResString(Count1), "=")
            Coor1 = Split(TempArr(0), ",")
            Coor2 = Split(TempArr(1), ",")
            Colors(Val(Coor1(0)), Val(Coor1(1)), Val(Coor1(2))) = Colors(Val(Coor2(0)), Val(Coor2(1)), Val(Coor2(2)))
            Colors(Val(Coor2(0)), Val(Coor2(1)), Val(Coor2(2))) = Temp
            Count2 = 0
        End If
    Next Count1
End Sub

Public Sub RotateCube(Colors() As OLE_COLOR, Axis As AxisEnum, Rotation As RotationEnum)
    Select Case Axis
        Case XAxis
            RotateFace Colors(), fFront, Rotation
            RotateFace Colors(), fBack, Rotation
        Case YAxis
            RotateFace Colors(), fLeft, Rotation
            RotateFace Colors(), fRight, Rotation
        Case ZAxis
            RotateFace Colors(), fTop, Rotation
            RotateFace Colors(), fBottom, Rotation
    End Select
    RotateMiddle Colors(), Axis, Rotation
End Sub
